function dist = H_dist(a,b)
% Computes Hausdorf distance between column vectors a and b
%
% Copyright 2015, Armin Eftekhari and Michael Wakin
%
% This file is part of the Greedy Super-Resolution Toolbox version 1.0.
%
%    The Greedy Super-Resolution Toolbox is free software: you can 
%    redistribute it and/or modify it under the terms of the GNU General 
%    Public License as published by the Free Software Foundation, either 
%    version 3 of the License, or (at your option) any later version.
%
%    The Greedy Super-Resolution Toolbox is distributed in the hope that it 
%    will be useful, but WITHOUT ANY WARRANTY; without even the implied 
%    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
%    See the GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with the Greedy Super-Resolution Toolbox.  If not, 
%    see <http://www.gnu.org/licenses/>.
%

% Make sure the entries are in [0,1)
a = mod(a,1);
b = mod(b,1);

temp = repmat(a,[1 length(b)])-repmat(b',[length(a) 1]);
temp1 = min([abs(temp(:)),1-abs(temp(:))],[],2);
temp2 = reshape(temp1,[length(a) length(b)]);

temp3 = max(min(temp2,[],2),[],1);
temp4 = max(min(temp2,[],1),[],2);

dist = max(temp3,temp4);

% end