function RhoOut = Proj(RhoIn,Rho,neigh)
% Projection onto the neighborhood of Rho of radius neigh
%
% Rho: estimate of phase 1
% RhoIn: current estimate to be projected
% neigh: proportional to sigma2
% RhoOut: projected estimate
%
% Copyright 2015, Armin Eftekhari and Michael Wakin
%
% This file is part of the Greedy Super-Resolution Toolbox version 1.0.
%
%    The Greedy Super-Resolution Toolbox is free software: you can 
%    redistribute it and/or modify it under the terms of the GNU General 
%    Public License as published by the Free Software Foundation, either 
%    version 3 of the License, or (at your option) any later version.
%
%    The Greedy Super-Resolution Toolbox is distributed in the hope that it 
%    will be useful, but WITHOUT ANY WARRANTY; without even the implied 
%    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
%    See the GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with the Greedy Super-Resolution Toolbox.  If not, 
%    see <http://www.gnu.org/licenses/>.
%

% Make sure everything is in [0,1)
RhoIn = mod(RhoIn,1);
Rho = mod(Rho,1);

dif1 = RhoIn-Rho > neigh;
RhoOut = RhoIn.*(1-dif1)+(Rho+neigh).*dif1;
dif2 = RhoOut-Rho < -neigh;
RhoOut = RhoOut.*(1-dif2)+(Rho-neigh).*dif2;

% if max((dif1 ~= 0)) || max((dif2 ~= 0))
%     display('Projection engaged!')
% end


end
